aboutsummaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
Diffstat (limited to 'tests')
-rw-r--r--tests/functional/common/vars-and-functions.sh.in1
-rw-r--r--tests/functional/gc-runtime.nix36
-rw-r--r--tests/functional/gc-runtime.sh32
3 files changed, 43 insertions, 26 deletions
diff --git a/tests/functional/common/vars-and-functions.sh.in b/tests/functional/common/vars-and-functions.sh.in
index b054bf834..3d2e44024 100644
--- a/tests/functional/common/vars-and-functions.sh.in
+++ b/tests/functional/common/vars-and-functions.sh.in
@@ -24,7 +24,6 @@ if [[ -n $NIX_STORE ]]; then
export _NIX_TEST_NO_SANDBOX=1
fi
export _NIX_IN_TEST=$TEST_ROOT/shared
-export _NIX_TEST_NO_LSOF=1
export NIX_REMOTE=${NIX_REMOTE_-}
unset NIX_PATH
export TEST_HOME=$TEST_ROOT/test-home
diff --git a/tests/functional/gc-runtime.nix b/tests/functional/gc-runtime.nix
index ee5980bdf..4303e0880 100644
--- a/tests/functional/gc-runtime.nix
+++ b/tests/functional/gc-runtime.nix
@@ -1,17 +1,29 @@
with import ./config.nix;
-mkDerivation {
- name = "gc-runtime";
- builder =
- # Test inline source file definitions.
- builtins.toFile "builder.sh" ''
- mkdir $out
+{
+ environ = mkDerivation {
+ name = "gc-runtime-environ";
+ buildCommand = "mkdir $out; echo environ > $out/environ";
+ };
- cat > $out/program <<EOF
- #! ${shell}
- sleep 10000
- EOF
+ open = mkDerivation {
+ name = "gc-runtime-open";
+ buildCommand = "mkdir $out; echo open > $out/open";
+ };
- chmod +x $out/program
- '';
+ program = mkDerivation {
+ name = "gc-runtime-program";
+ builder =
+ # Test inline source file definitions.
+ builtins.toFile "builder.sh" ''
+ mkdir $out
+
+ cat > $out/program <<EOF
+ #! ${shell}
+ sleep 10000 < \$1
+ EOF
+
+ chmod +x $out/program
+ '';
+ };
}
diff --git a/tests/functional/gc-runtime.sh b/tests/functional/gc-runtime.sh
index dc1826a55..6e17acfc0 100644
--- a/tests/functional/gc-runtime.sh
+++ b/tests/functional/gc-runtime.sh
@@ -1,38 +1,44 @@
source common.sh
-case $system in
- *linux*)
- ;;
- *)
- skipTest "Not running Linux";
-esac
-
set -m # enable job control, needed for kill
profiles="$NIX_STATE_DIR"/profiles
rm -rf $profiles
-nix-env -p $profiles/test -f ./gc-runtime.nix -i gc-runtime
+nix-env -p $profiles/test -f ./gc-runtime.nix -i gc-runtime-{program,environ,open}
-outPath=$(nix-env -p $profiles/test -q --no-name --out-path gc-runtime)
-echo $outPath
+programPath=$(nix-env -p $profiles/test -q --no-name --out-path gc-runtime-program)
+environPath=$(nix-env -p $profiles/test -q --no-name --out-path gc-runtime-environ)
+openPath=$(nix-env -p $profiles/test -q --no-name --out-path gc-runtime-open)
+echo $programPath $environPath $openPath
echo "backgrounding program..."
-$profiles/test/program &
+export environPath
+$profiles/test/program $openPath/open &
sleep 2 # hack - wait for the program to get started
child=$!
echo PID=$child
-nix-env -p $profiles/test -e gc-runtime
+nix-env -p $profiles/test -e gc-runtime-{program,environ,open}
nix-env -p $profiles/test --delete-generations old
nix-store --gc
kill -- -$child
-if ! test -e $outPath; then
+if ! test -e $programPath; then
echo "running program was garbage collected!"
exit 1
fi
+if ! test -e $environPath; then
+ echo "file in environment variable was garbage collected!"
+ exit 1
+fi
+
+if ! test -e $openPath; then
+ echo "opened file was garbage collected!"
+ exit 1
+fi
+
exit 0